-- Based on ARMOR POCKETS script

-- Placed Equipment
script.on_event(defines.events.on_player_placed_equipment, function(event)

	local player = game.players[event.player_index]    
    local craftingSpeed = player.character_crafting_speed_modifier
	local health = player.character_health_bonus
    local logisticSlots = player.character_logistic_slot_count_bonus
	local quickbar = player.quickbar_count_bonus 
	
	-- check if we are adding an armor pocket
    if event.equipment.name == "Craft-Assistent" then

	    -- add the bonus
		player.character_crafting_speed_modifier = craftingSpeed + 0.5
				
    	-- --log the inventory slot count to console
		--log_crafting_Bonus(player)
    end
	if event.equipment.name == "Extra-Shield" then

	    -- add the bonus
	    player.character_health_bonus = health + 250
				
        -- --log the inventory slot count to console
	    --log_health_Bonus(player)
    end
	if event.equipment.name == "Portable-Logistic-Computer" then

	    -- add the bonus
	    player.character_logistic_slot_count_bonus = logisticSlots + 2
				
        -- --log the inventory slot count to console
	    --log_logistic_Bonus(player)
    end
	if event.equipment.name == "Extra-Toolbelt" then

	    -- add the bonus
	    player.quickbar_count_bonus = quickbar + 1
				
        -- --log the inventory slot count to console
	    --log_quickbar_Bonus(player)
    end
end
)


script.on_event(defines.events.on_player_removed_equipment, function(event)
 
 	local player = game.players[event.player_index]
    local crafting_speed_bonus = player.character_crafting_speed_modifier
	local health_bonus = player.character_health_bonus
    local logisti_slots_bonus = player.character_logistic_slot_count_bonus
	local quickbar_bonus = player.quickbar_count_bonus 

  	if event.equipment == "Craft-Assistent" then

  		if event.count >= 0 then

	  		local craftingCount = crafting_speed_bonus - (0.5 * event.count)
			
	  		if craftingCount >= 0 then
				crafting_speed_bonus = craftingCount

				player.character_crafting_speed_modifier = crafting_speed_bonus
			end
		end
    end
  	if event.equipment == "Extra-Shield" then

  		if event.count >= 0 then

	  		local healthCount = health_bonus - (250 * event.count)
			
	  		if healthCount >= 0 then
				health_bonus = healthCount

				player.character_health_bonus = health_bonus
			end

		end
    end
  	if event.equipment == "Portable-Logistic-Computer" then

  		if event.count >= 0 then

	  		local logisticCount = logisti_slots_bonus - (2 * event.count)
			
	  		if logisticCount >= 0 then
				logisti_slots_bonus = logisticCount

				player.character_logistic_slot_count_bonus = logisti_slots_bonus
			end

		end
    end
  	if event.equipment == "Extra-Toolbelt" then

  		if event.count >= 0 then

	  		local toolbeltCount = quickbar_bonus - (1 * event.count)
			
	  		if toolbeltCount >= 0 then
				quickbar_bonus = toolbeltCount

				player.quickbar_count_bonus = quickbar_bonus
			end

		end
    end
end
)

script.on_event(defines.events.on_player_armor_inventory_changed, function(event)
 
  	local player = game.players[event.player_index]
	local armor = player.get_inventory(defines.inventory.player_armor)

	if not armor.is_empty() then
		
		local total_crafting = 0
		local total_health = 0
		local total_logistic = 0
		local total_quickbar = 0
				
		local grid = armor[1].grid

		if grid ~= nil then

			for i = 1, #grid.equipment do
			
				if grid.equipment[i].name == "Craft-Assistent" then
					total_crafting = total_crafting + 0.5
				end
				if grid.equipment[i].name == "Extra-Shield" then
					total_health = total_health + 250
				end
				if grid.equipment[i].name == "Portable-Logistic-Computer" then
					total_logistic = total_logistic + 2
				end
				if grid.equipment[i].name == "Extra-Toolbelt" then
					total_quickbar = total_quickbar + 1
				end

			end

			set_inventory1(player, total_crafting)
			set_inventory2(player, total_health)			
			set_inventory3(player, total_logistic)
			set_inventory4(player, total_quickbar)			
			
		else
			clear_all_bonuses(player)			

		end	

	else
		clear_all_bonuses(player)
	end

end
)

function clear_all_bonuses(player)

	player.character_crafting_speed_modifier = 0
	player.character_health_bonus = 0
	player.character_logistic_slot_count_bonus = 0
	player.quickbar_count_bonus = 0
	
end

function set_inventory1(player, count)
	player.character_crafting_speed_modifier = count
end

function set_inventory2(player, count)
	player.character_health_bonus = count
end

function set_inventory3(player, count)
	player.character_logistic_slot_count_bonus = count
end
function set_inventory4(player, count)
	player.quickbar_count_bonus = count
end

function log_crafting_Bonus(player)
	player.print("Character crafting speed: +" .. player.character_crafting_speed_modifier)	
end

function log_health_Bonus(player)
	player.print("Character health bonus: +" .. player.character_health_bonus)	
end

function log_logistic_Bonus(player)
	player.print("Character logistic slots bonus: +" .. player.character_logistic_slot_count_bonus)	
end

function log_quickbar_Bonus(player)
	player.print("Additional tool belts: +" .. player.quickbar_count_bonus)	
end