--Because Angel's Industries for some god forsaken reason edits loader graphics in this file, we too must do so here to put it back.
-- Create color masks
local tint_mask = {
	["basic-loader"]   = {r = 222, g = 222, b = 222}, -- Corrected 6-12-2018 11:05 AM
	["loader"] 		   = {r = 245, g = 198, b =  56}, -- Corrected 6-12-2018 11:03 AM
	["fast-loader"]    = {r = 242, g =  48, b =  61}, -- Corrected 6-12-2018 11:02 AM
	["express-loader"] = {r = 115, g = 193, b = 229}, -- Corrected 6-12-2018 11:07 AM
	["purple-loader"]  = {r = 168, g =  47, b = 237}, -- Corrected 6-12-2018 11:41 AM
	["green-loader"]   = {r =  55, g = 240, b =  86}, -- Corrected 6-12-2018 11:49 AM
}

local hr_tint_mask = {
	["basic-loader"]   = {r = 222, g = 222, b = 222}, -- Corrected 6-10-2018  2:05 PM
	["loader"] 		   = {r = 229, g = 187, b =  46}, -- Corrected 6-10-2018 12:24 PM
	["fast-loader"]    = {r = 229, g =  37, b =  37}, -- Corrected 6-10-2018  1:48 PM
	["express-loader"] = {r =  78, g = 192, b = 245}, -- Corrected 6-10-2018  1:54 PM
	["purple-loader"]  = {r = 197, g =  76, b = 245}, -- Corrected 6-10-2018  2:00 PM
	["green-loader"]   = {r =  77, g = 229, b =  34}, -- Corrected 6-10-2018  2:04 PM
}

-- Called by make_loader_entity. Creates the icon, and low/high resolution graphics.
local function patch_loader_entity(loader)
	if loader then
		local name = loader.name
		-- loader.icon = "__vanilla-loaders-hd__/graphics/icons/"..name..".png"
		-- loader.fast_replaceable_group = "loader"
		
		loader.structure.direction_in.sheets = 
		{
			{
				filename = "__vanilla-loaders-hd__/graphics/entity/loader/loader-structure-base.png",				
				width    = 96,
				height   = 64,
				y        = 0,
				hr_version = 
				{
					filename = "__vanilla-loaders-hd__/graphics/entity/loader/hr-loader-structure-base.png",
					height   = 128,
					priority = "extra-high",
					scale    = 0.5,
					width    = 192,
					y        = 0
				}
			},
			{
				filename = "__vanilla-loaders-hd__/graphics/entity/loader/loader-structure-mask.png",			
				width    = 96,
				height   = 64,
				y        = 0,
				tint	 = tint_mask[name],
				hr_version = 
				{
					filename = "__vanilla-loaders-hd__/graphics/entity/loader/hr-loader-structure-mask.png",
					height   = 128,
					priority = "extra-high",
					scale    = 0.5,
					width    = 192,
					y        = 0,
					tint     = hr_tint_mask[name]
				}
			}
		}
		loader.structure.direction_out.sheets = 
		{
			{
				filename = "__vanilla-loaders-hd__/graphics/entity/loader/loader-structure-base.png",			
				width    = 96,
				height   = 64,
				y        = 64,
				hr_version = 
				{
					filename = "__vanilla-loaders-hd__/graphics/entity/loader/hr-loader-structure-base.png",
					height   = 128,
					priority = "extra-high",
					scale    = 0.5,
					width    = 192,
					y        = 128
				}
			},
			{
				filename = "__vanilla-loaders-hd__/graphics/entity/loader/loader-structure-mask.png",			
				width    = 96,
				height   = 64,
				y        = 64,
				tint	 = tint_mask[name],
				hr_version = 
				{
					filename = "__vanilla-loaders-hd__/graphics/entity/loader/hr-loader-structure-mask.png",
					height   = 128,
					priority = "extra-high",
					scale    = 0.5,
					width    = 192,
					y        = 128,
					tint     = hr_tint_mask[name]
				}
			}
		}
	end
end

-- Vanilla Loader patching
patch_loader_entity(data.raw["loader"]["loader"])
patch_loader_entity(data.raw["loader"]["fast-loader"])
patch_loader_entity(data.raw["loader"]["express-loader"])